## massxpert 7.0.0

=== CMakeLists.txt ===
#############################################################
#############################################################
# CMake configuration
cmake_minimum_required(VERSION 3.12)

############################################################
############################################################
# Basic information about project

project(massXpert
  DESCRIPTION "A program to model and simulate mass spectra on (bio-)polymers"
  HOMEPAGE_URL "http://wwww.msxpertsuite.org/massxpert")

set(VERSION 7.0.0)


include(GNUInstallDirs)

set(HOME_DEVEL_DIR $ENV{HOME}/devel)
message("\n${BoldRed}The devel directory where all the development projects
should reside: ${HOME_DEVEL_DIR}.${ColourReset}\n")


# Add folder where are supportive functions
set(CMAKE_UTILS_PATH ${CMAKE_SOURCE_DIR}/CMakeStuff)
set(CMAKE_TOOLCHAINS_PATH ${CMAKE_UTILS_PATH}/toolchains)
set(CMAKE_MODULE_PATH ${CMAKE_UTILS_PATH}/modules)

# This include must come before all the others
# It must include the config-generated config.h file
# before the others.
include_directories(${CMAKE_BINARY_DIR})

# And now the source directory contains the .h|.hpp files for its .cpp files.
include_directories(${CMAKE_SOURCE_DIR})

# For the config.h file.
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Include the system's uname that fills in SYSTEM_UNAME_S.
# Sets WIN32 if SYSTEM_UNAME_S is "^.*MING64.*"
# Note that WIN32 is set even on 64 bits systems.
include(${CMAKE_UTILS_PATH}/systemUname.cmake)

# Include the various colors we want to use in the output
include(${CMAKE_UTILS_PATH}/outputColors.cmake)

set(CMAKE_COLOR_MAKEFILE ON)
set(CMAKE_VERBOSE_MAKEFILE ON)

message("\n${BoldRed}Configuring build for project ${CMAKE_PROJECT_NAME}${ColourReset}\n")

# This export will allow using the flags to be used by
# youcompleteme (vim plugin).
set(CMAKE_EXPORT_COMPILE_COMMANDS 1)

if(EXISTS "${CMAKE_CURRENT_BINARY_DIR}/compile_commands.json" )
  execute_process( COMMAND cmake -E copy_if_different
    ${CMAKE_CURRENT_BINARY_DIR}/compile_commands.json
    ${CMAKE_CURRENT_SOURCE_DIR}/compile_commands.json
    )
endif()


# We want C++17
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
message(STATUS "${BoldGreen}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")

#############################################################
# We do not want warnings for unknown pragmas:
message(STATUS "Setting definition -Wno-unknown-pragmas.${ColourReset}")
add_definitions(-Wno-unknown-pragmas)

# Enable warnings and possibly treat them as errors
message(STATUS "${BoldGreen}Setting definition -Wall -pedantic.${ColourReset}")
add_definitions(-Wall -pedantic)
message(STATUS "${BoldGreen}Setting definition -Wextra.${ColourReset}")
add_definitions(-Wextra)

if(WARN_AS_ERROR)
  message(STATUS "${BoldYellow}Setting definition -Werror.${ColourReset}")
  add_definitions(-Werror)
endif()

message("${BoldGreen}CMAKE_SOURCE_DIR: ${CMAKE_SOURCE_DIR}${ColourReset}")


#############################################################
#############################################################
# Platform-specific CMake configuration
if(WIN32 OR _WIN32)

  if(MXE)

    # Run the following cmake command line:
    # x86_64-w64-mingw32.shared-cmake -DCMAKE_BUILD_TYPE=Release -DMXE=1 ../../development
    include(${CMAKE_TOOLCHAINS_PATH}/mxe-toolchain.cmake)

    # Set the name to the systemUname variable because in this situation that name
    # is not found, it it passed as a flag in the command line.
    set(SYSTEM_UNAME_S "mxe")

  elseif(WIN10MINGW64)
    include(${CMAKE_TOOLCHAINS_PATH}/win10-mingw64-toolchain.cmake)
  endif()

elseif(UNIX AND NOT APPLE)

  include(${CMAKE_TOOLCHAINS_PATH}/unix-toolchain.cmake)

elseif(APPLE)

  include(${CMAKE_TOOLCHAINS_PATH}/apple-macport-toolchain.cmake)

endif()

message("")
message(STATUS "${BoldGreen}Starting configuration of ${CMAKE_PROJECT_NAME}${ColourReset}")
message("")
message(STATUS "${BoldYellow}The build toolchain is: ${SYSTEM_UNAME_S}${ColourReset}")
message("")


#############################################################
#############################################################
# Essential software configuration
message(STATUS "CMAKE_CURRENT_BINARY_DIR: " ${CMAKE_CURRENT_BINARY_DIR})

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release CACHE STRING
    "Type of build, options are: None, Debug, Release, RelWithDebInfo, MinSizeRel."
    FORCE)
endif(NOT CMAKE_BUILD_TYPE)

if(CMAKE_BUILD_TYPE MATCHES "Release")
  message(STATUS "Compiling in release mode.")
  add_definitions("-DQT_NO_DEBUG_OUTPUT")
endif()

if(CMAKE_BUILD_TYPE MATCHES "Debug")
  message(STATUS "Compiling in debug mode.")
  message(STATUS "Add definition -ggdb3 to format debug output for GDB.")
  add_definitions(-ggdb3)
endif()

if(CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo")
  message(STATUS "Compiling in release with debug info mode.")
endif( CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo" )

message(STATUS "${BoldYellow}CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}.${ColourReset}")


# Set additional project information
set(COMPANY "msXpertSuite.org")
set(COPYRIGHT "Copyright (c) 2008-2022 Filippo Rusconi. Licensed under GPLv3+")
set(IDENTIFIER "org.msxpertsuite")


if(PROFILE)
  message(STATUS "${BoldYellow}Profiling is requested, adding -pg flag.${ColourReset}")
  add_definitions(-pg)
endif()

message(STATUS "${BoldYellow}Main CMAKE_BINARY_DIR: ${CMAKE_BINARY_DIR}${ColourReset}")
message(STATUS "${BoldYellow}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")


# It is essential to run these config steps before delving into the minexpert
# directory, because at that moment they will need what are
# going to prepare right now.
CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/CMakeStuff/splashscreen.svg.in
  ${CMAKE_SOURCE_DIR}/images/svg/splashscreen.svg @ONLY)

# Make the conversion of the svg file into a png, but only on GNU/Linux
if(UNIX AND NOT APPLE)
  execute_process(COMMAND convert ${CMAKE_SOURCE_DIR}/images/svg/splashscreen.svg
    ${CMAKE_SOURCE_DIR}/images/splashscreen.png)
endif()

#############################################################
######################
# BUILD OF THE PROGRAM

message(STATUS "Adding subdirectory src for TARGET: ${TARGET}")
add_subdirectory(src)

####################################################
# Installation directories depending on the platform
####################################################

# See the CMakeStuff/toolchains platform-specific files.
message(STATUS "CMAKE_INSTALL_PREFIX: ${CMAKE_INSTALL_PREFIX}")
message(STATUS "BIN_DIR: ${BIN_DIR}")
message(STATUS "DATA_DIR: ${DATA_DIR}")
message(STATUS "DOC_DIR: ${DOC_DIR}")


#############################################################
###################
# BUILD OF THE DATA
message(STATUS "Adding subdirectory data for project: ${CMAKE_PROJECT_NAME}")
add_subdirectory(data)


#############################################################
################################
# BUILD OF THE DOC / USER MANUAL
message(STATUS "Adding subdirectory doc for project: ${CMAKE_PROJECT_NAME}")
add_subdirectory(doc)


# Use all the configured paths to create the config.h file.
# The config file is binary directory-specific !!!
CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/CMakeStuff/config.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/src/config.h @ONLY)


#############################################################
# summary
message("")
message(STATUS "${BoldRed}~~~~~~~~~~~~~~~~~~~~~~~~ SUMMARY ~~~~~~~~~~~~~~~~~~~~~~~~${ColourReset}")
message(STATUS "${BoldRed}   General configuration of the msXpertSuite project ${ColourReset}")
message("")

message(STATUS "${BoldYellow}System is detected by CMake as ${SYSTEM_UNAME_S}${ColourReset}")
message(STATUS "${BoldYellow}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")
message(STATUS "${BoldYellow}CMAKE_CXX_STANDARD: ${CMAKE_CXX_STANDARD}${ColourReset}")

message("")

message(STATUS "${BoldYellow}CMAKE_INSTALL_PREFIX: ${CMAKE_INSTALL_PREFIX}${ColourReset}")
message(STATUS "${BoldYellow}TARGET: ${TARGET}${ColourReset}")
message(STATUS "${BoldYellow}BIN_DIR: ${BIN_DIR}${ColourReset}")
message(STATUS "${BoldYellow}DOC_DIR: ${DOC_DIR}${ColourReset}")

if(PROFILE)
  message(STATUS "${BoldYellow}Profiling is requested (-DPROFILE=1)${ColourReset}")
else()
  message(STATUS "${BoldYellow}Profiling is NOT requested (-DPROFILE=0)${ColourReset}")
endif()

if(WARNASERR)
  message(STATUS "${BoldYellow}Warnings ARE treated as errors (-DWARNASERR=1)${ColourReset}")
else()
  message(STATUS "${BoldYellow}Warnings NOT treated as errors (-DWARNASERR=0)${ColourReset}")
endif()

if(CMAKE_BUILD_TYPE STREQUAL "Debug")
  message(STATUS "${BoldYellow}Debug support IS requested.${ColourReset}")
else()
  message(STATUS "${BoldYellow}Debug support NOT requested.${ColourReset}")
endif()

message("")
message(STATUS "${BoldYellow}The typical cmake invocation on Debian GNU/Linux would be: cmake -DCMAKE_BUILD_TYPE=Debug -DBUILD_USER_MANUAL=1 ../../development${ColourReset}")
message(STATUS "${BoldYellow}The typical cmake invocation on win10-mingw64 would be: cmake -DCMAKE_BUILD_TYPE=Release  ../../development${ColourReset}") 
message(STATUS "${BoldYellow}The typical cmake invocation on MXE would be: x86_64-w64-mingw32.shared-cmake -DCMAKE_BUILD_TYPE=Release -DMXE=1 ../../development${ColourReset}") 
message("")

message("")
message(STATUS "${BoldRed}~~~~~~~~~~~~~~~~~~~~~~~~ SUMMARY ~~~~~~~~~~~~~~~~~~~~~~~~${ColourReset}")
message("")

=== doc/CMakeLists.txt ===
message("")
message(STATUS "${BoldGreen}Starting configuration for the doc material for ${CMAKE_PROJECT_NAME} ${ColourReset}")
message("")

# The UNIX man pages
if(UNIX AND NOT APPLE)

  message(STATUS "Going to generate the man pages.")

  execute_process(COMMAND docbook-to-man massxpert.xml
    OUTPUT_FILE	${CMAKE_BINARY_DIR}/massxpert.1
    WORKING_DIRECTORY	${CMAKE_CURRENT_SOURCE_DIR})

endif(UNIX AND NOT APPLE)


###############
# install stuff

# The history and licence files.

message("Installing the doc files in ${DOC_DIR}")
install(FILES history.html ../LICENSE 
  DESTINATION ${DOC_DIR})

# The man page.
if(UNIX AND NOT APPLE)
  install(FILES ${CMAKE_BINARY_DIR}/massxpert.1
    ${CMAKE_BINARY_DIR}/massxpert.1
    DESTINATION ${CMAKE_INSTALL_PREFIX}/share/man/man1)
endif()


#############################################################
###########################
# BUILD OF THE USER MANUALS

if(BUILD_USER_MANUAL)
  add_subdirectory(user-manual)
endif()


message("")
message(STATUS "${BoldGreen}Finished configuration of the doc material.${ColourReset}")
message("")

=== src/CMakeLists.txt ===
message(\n${BoldRed}"Now configuring src/ for ${TARGET}"${ColourReset}\n)


########################################################
# Files
set(${TARGET}_nongui_SRCS
  #
  # Some globals.
  nongui/globals.cpp
  #
  # The classes that define the polymer chemistry
  nongui/Atom.cpp
  nongui/AtomCount.cpp
  nongui/ChemicalGroup.cpp
  nongui/ChemicalGroupRule.cpp
  nongui/CleaveMotif.cpp
  nongui/CleaveOligomer.cpp
  nongui/CleaveOptions.cpp
  nongui/CleaveRule.cpp
  nongui/CleaveSpec.cpp
  nongui/Cleaver.cpp
  nongui/CrossLink.cpp
  nongui/CrossLinkList.cpp
  nongui/CrossLinkedRegion.cpp
  nongui/CrossLinker.cpp
  nongui/CrossLinkerSpec.cpp
  nongui/Formula.cpp
  nongui/FragOptions.cpp
  nongui/FragRule.cpp
  nongui/FragSpec.cpp
  nongui/Fragmenter.cpp
  nongui/Ionizable.cpp
  nongui/IonizeRule.cpp
  nongui/Isotope.cpp
  nongui/Modif.cpp
  nongui/ModifSpec.cpp
  nongui/Monomer.cpp
  nongui/MonomerDictionary.cpp
  nongui/MonomerSpec.cpp
  nongui/Oligomer.cpp
  nongui/OligomerList.cpp
  nongui/OligomerPair.cpp
  nongui/PkaPhPi.cpp
  nongui/PkaPhPiDataParser.cpp
  nongui/PolChemDef.cpp
  nongui/PolChemDefCatParser.cpp
  nongui/PolChemDefEntity.cpp
  nongui/PolChemDefSpec.cpp
  nongui/Polymer.cpp
  nongui/Ponderable.cpp
  #
  # The sequence class.
  nongui/Sequence.cpp
  #
  # Utility classes
  nongui/Coordinates.cpp
  nongui/CalcOptions.cpp
  nongui/MassList.cpp
  #
  # Graphical representation of chemical entities
  nongui/ChemEntVignette.cpp
  nongui/ChemEntVignetteRenderer.cpp
  nongui/PeakCentroid.cpp
  #
  # The property system.
  nongui/Prop.cpp
  nongui/PropListHolder.cpp
  #
  # The user/system configuration
  nongui/ConfigSetting.cpp
  nongui/ConfigSettings.cpp
  nongui/UserSpec.cpp
)

set(${TARGET}_gui_SRCS
  main.cpp
  gui/AboutDlg.cpp
  gui/AbstractMainTaskWindow.cpp
  gui/AbstractPolChemDefDependentDlg.cpp
  gui/AbstractSeqEdWndDependentDlg.cpp
  gui/Application.cpp
  gui/AtomDefDlg.cpp
  gui/CalculatorChemPadDlg.cpp
  gui/CalculatorChemPadGroupBox.cpp
  gui/CalculatorRecorderDlg.cpp
  gui/CalculatorWnd.cpp
  gui/ChemPadButton.cpp
  gui/CleavageDlg.cpp
  gui/CleaveOligomerTableView.cpp
  gui/CleaveOligomerTableViewMimeData.cpp
  gui/CleaveOligomerTableViewModel.cpp
  gui/CleaveOligomerTableViewSortProxyModel.cpp
  gui/CleaveSpecDefDlg.cpp
  gui/CompositionTreeView.cpp
  gui/CompositionTreeViewItem.cpp
  gui/CompositionTreeViewModel.cpp
  gui/CompositionTreeViewSortProxyModel.cpp
  gui/CompositionsDlg.cpp
  gui/ConfigSettingsDlg.cpp
  gui/CrossLinkerDefDlg.cpp
  gui/DecimalPlacesOptionsDlg.cpp
  gui/FragSpecDefDlg.cpp
  gui/FragmentOligomerTableView.cpp
  gui/FragmentOligomerTableViewMimeData.cpp
  gui/FragmentOligomerTableViewModel.cpp
  gui/FragmentOligomerTableViewSortProxyModel.cpp
  gui/FragmentationDlg.cpp
  gui/MainWindow.cpp
  gui/MassListSorterDlg.cpp
  gui/MassSearchDlg.cpp
  gui/MassSearchOligomerTableView.cpp
  gui/MassSearchOligomerTableViewMimeData.cpp
  gui/MassSearchOligomerTableViewModel.cpp
  gui/MassSearchOligomerTableViewSortProxyModel.cpp
  gui/ModifDefDlg.cpp
  gui/MonomerCodeEvaluator.cpp
  gui/MonomerCrossLinkDlg.cpp
  gui/MonomerDefDlg.cpp
  gui/MonomerModificationDlg.cpp
  gui/MzCalculationDlg.cpp
  gui/MzCalculationTreeView.cpp
  gui/MzCalculationTreeViewItem.cpp
  gui/MzCalculationTreeViewModel.cpp
  gui/MzCalculationTreeViewSortProxyModel.cpp
  gui/MzLabFormulaBasedActionsDlg.cpp
  gui/MzLabInputOligomerTableView.cpp
  gui/MzLabInputOligomerTableViewDlg.cpp
  gui/MzLabInputOligomerTableViewModel.cpp
  gui/MzLabInputOligomerTableViewSortProxyModel.cpp
  gui/MzLabMassBasedActionsDlg.cpp
  gui/MzLabMatchBasedActionsDlg.cpp
  gui/MzLabOutputOligomerTableView.cpp
  gui/MzLabOutputOligomerTableViewDlg.cpp
  gui/MzLabOutputOligomerTableViewModel.cpp
  gui/MzLabOutputOligomerTableViewSortProxyModel.cpp
  gui/MzLabWnd.cpp
  gui/PkaPhPiDlg.cpp
  gui/PolChemDefWnd.cpp
  gui/PolymerModificationDlg.cpp
  gui/RegionSelection.cpp
  gui/SeqToolsDlg.cpp
  gui/SequenceEditorFindDlg.cpp
  gui/SequenceEditorGraphicsView.cpp
  gui/SequenceEditorGraphicsViewKeySequenceHandling.cpp
  gui/SequenceEditorGraphicsViewKeyboardHandling.cpp
  gui/SequenceEditorWnd.cpp
  gui/SequenceImportDlg.cpp
  gui/SequencePurificationDlg.cpp
  gui/SequenceSelection.cpp
)

set(${TARGET}_UIS
  gui/ui/AboutDlg.ui
  gui/ui/AbstractPolChemDefDependentDlg.ui
  gui/ui/AtomDefDlg.ui
  gui/ui/CalculatorChemPadDlg.ui
  gui/ui/CalculatorRecorderDlg.ui
  gui/ui/CalculatorWnd.ui
  gui/ui/CleavageDlg.ui
  gui/ui/CleaveSpecDefDlg.ui
  gui/ui/CompositionsDlg.ui
  gui/ui/ConfigSettingsDlg.ui
  gui/ui/CrossLinkerDefDlg.ui
  gui/ui/DecimalPlacesOptionsDlg.ui
  gui/ui/FragSpecDefDlg.ui
  gui/ui/FragmentationDlg.ui
  gui/ui/MassSearchDlg.ui
  gui/ui/ModifDefDlg.ui
  gui/ui/MonomerCrossLinkDlg.ui
  gui/ui/MonomerDefDlg.ui
  gui/ui/MonomerModificationDlg.ui
  gui/ui/MzCalculationDlg.ui
  gui/ui/MzLabFormulaBasedActionsDlg.ui
  gui/ui/MzLabInputOligomerTableViewDlg.ui
  gui/ui/MzLabMassBasedActionsDlg.ui
  gui/ui/MzLabMatchBasedActionsDlg.ui
  gui/ui/MzLabOutputOligomerTableViewDlg.ui
  gui/ui/MzLabWnd.ui
  gui/ui/NumeralsLocaleConverterDlg.ui
  gui/ui/PkaPhPiDlg.ui
  gui/ui/PolChemDefWnd.ui
  gui/ui/PolymerModificationDlg.ui
  gui/ui/SequenceEditorFindDlg.ui
  gui/ui/SequenceEditorWnd.ui
  gui/ui/SequenceImportDlg.ui
  gui/ui/SequencePurificationDlg.ui
)

find_package(Qt6 COMPONENTS Widgets Xml Svg SvgWidgets PrintSupport REQUIRED)

qt6_wrap_ui(${TARGET}_UIS_H ${${TARGET}_UIS})

qt6_add_resources(${TARGET}_QRC_CPP ../massxpert.qrc)

# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

### These two lines required because now CMake only automocs
### the generated files and not the source files.
# NOT sure about this. Let's comment that for the moment.
# set_source_files_properties(${${TARGET}_UIS_H} PROPERTIES SKIP_AUTOMOC ON)
# set_source_files_properties(${${TARGET}_QRC_CPP} PROPERTIES SKIP_AUTOMOC ON)

include_directories(

  # The config file is binary directory-specific !!!
  # For the config.h file generated from config.h.in
  # For the ui_Xyyyyy.h files
  ${CMAKE_CURRENT_BINARY_DIR}

  # For all the source subdirectories
  ${CMAKE_SOURCE_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}
)


###############################################################
# Configuration of the binary to be built
###############################################################

# Only now can we add the executable, because we have defined the sources of the
# object library above.

if(WIN32 OR _WIN32)

  add_executable(${TARGET} WIN32
    ${${TARGET}_nongui_SRCS}
    ${${TARGET}_gui_SRCS}
    ${${TARGET}_UIS_H}
    ${${TARGET}_QRC_CPP}
    ${PLATFORM_SPECIFIC_SOURCES}
  )

elseif(UNIX AND NOT APPLE)

  add_executable(${TARGET}
    ${${TARGET}_nongui_SRCS}
    ${${TARGET}_gui_SRCS}
    ${${TARGET}_UIS_H}
    ${${TARGET}_QRC_CPP}
    ${PLATFORM_SPECIFIC_SOURCES}
  )

elseif(APPLE)

  # Copy the icon file to the Contents/Resources directory of the bundle at
  # location ${MACOSX_PACKAGE_LOCATION}.
  set_source_files_properties(${CMAKE_SOURCE_DIR}/images/icons/${TARGET}.icns 
    PROPERTIES MACOSX_PACKAGE_LOCATION Resources)

  # Identify MacOS bundle

  set(MACOSX_BUNDLE_BUNDLE_NAME ${TARGET})
  message(STATUS "MACOSX_BUNDLE_BUNDLE_NAME: ${MACOSX_BUNDLE_BUNDLE_NAME}")

  set(MACOSX_BUNDLE_BUNDLE_VERSION ${PROJECT_VERSION})
  set(MACOSX_BUNDLE_LONG_VERSION_STRING ${PROJECT_VERSION})
  set(MACOSX_BUNDLE_SHORT_VERSION_STRING ${PROJECT_VERSION})
  set(MACOSX_BUNDLE_COPYRIGHT ${COPYRIGHT})
  set(MACOSX_BUNDLE_GUI_IDENTIFIER ${IDENTIFIER})
  set(MACOSX_BUNDLE_ICON_FILE ../images/icons/${TARGET}.icns)

  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mmacosx-version-min=10.9"
    CACHE STRING "Flags used by the compiler during all build types." FORCE)

  #set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility-inlines-hidden"
  #CACHE STRING "Flags used by the compiler during all build types." FORCE)

  set(CMAKE_OSX_SYSROOT "/Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/MacOSX10.12.sdk/"
    CACHE STRING "MacOSX10.12.sdk." FORCE)

  add_executable(${TARGET} MACOSX_BUNDLE
    ${${TARGET}-exec_SRCS}
    ${${TARGET}_nongui_SRCS}
    ${${TARGET}_gui_SRCS}
    ${${TARGET}_UIS_H}
    ${${TARGET}_QRC_CPP}
    ../images/icons/${TARGET}.icns
  )

  set_target_properties(${TARGET} PROPERTIES MACOSX_BUNDLE_ICON_FILE ${TARGET}.icns)

endif()


# Finally actually set the linking dependencies to the executable.
target_link_libraries(${TARGET}
  Qt6::Widgets
  Qt6::Xml
  Qt6::Svg
  Qt6::SvgWidgets
  Qt6::PrintSupport
)


#### Debugging stuff
message(STATUS required_target_link_libraries: ${required_target_link_libraries})

message(STATUS "Now printing all the include directories -I...")

get_property(dirs DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY INCLUDE_DIRECTORIES)
foreach(dir ${dirs})
  message(STATUS "included dir='${dir}'")
endforeach()

message(STATUS "Now printing all the linking directories -L...")

get_property(dirs DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY LINK_DIRECTORIES)
foreach(dir ${dirs})
  message(STATUS "link directory dir='${dir}'")
endforeach()

if(PROFILE)
  message(STATUS "Profiling is requested, adding linker -pg flag.")
  set (CMAKE_EXE_LINKER_FLAGS "-pg")
endif()

if(NOT APPLE)
  # We want to install the binary arch-dependent target in
  # specific situations. To have proper control, we define the arch
  # component.
  install(TARGETS ${TARGET}
    RUNTIME
    COMPONENT arch
    DESTINATION ${BIN_DIR})
endif()


message("")
message(STATUS "${BoldGreen}Finished configuring of ${TARGET}.${ColourReset}")
message("")

=== tests/CMakeLists.txt ===
# Get the name of the current directory but with no path:
get_filename_component(PATHNAME ${CMAKE_CURRENT_BINARY_DIR} ABSOLUTE)

message("")
message(STATUS "${BoldGreen}Start processing ${PATHNAME} dir.${ColourReset}")
message("")

set(TARGET tests)

########################################################
# Files

# We use the object file collection system of CMake (they call the library an
# "OBJECT" library type). The list of compiled object files from minexpert are
# stored in $<TARGET_OBJECTS:minexpert-objlib>. We use that identifier so as to
# avoid recompilation of the files for the testing purpose.

# But we also have the source files of the tests, these files are distributed
# among the various directories : src/libmass and src/minexpert at the moment.

file(GLOB ${TARGET}_libmassTest_SRCS
	src/libmass/*.cpp)

file(GLOB ${TARGET}_minexpertTest_SRCS
	src/minexpert/*.cpp)

set(SRCTEST
	src/testmain.cpp
	${${TARGET}_minexpertTest_SRCS}
	${${TARGET}_libmassTest_SRCS})

# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

find_package(Qt5 COMPONENTS Widgets Xml Svg Sql Script)

qt5_wrap_ui(${TARGET}_UIS_H ${${TARGET}_UIS})

qt5_add_resources(${TARGET}QRC_CPP gui/application.qrc)

add_executable(${TARGET}
	${SRCTEST}
	$<TARGET_OBJECTS:minexpert-objlib>)

target_compile_definitions(${TARGET} PRIVATE TESTS) #add -DTESTS
set_property(TARGET ${TARGET} PROPERTY CXX_STANDARD 14) # we want C++14

qt5_use_modules(${TARGET} Widgets)
qt5_use_modules(${TARGET} Xml)
qt5_use_modules(${TARGET} Svg)
qt5_use_modules(${TARGET} Sql)
qt5_use_modules(${TARGET} Script)
qt5_use_modules(${TARGET} PrintSupport)

include_directories(
	# For the config.h file generated from config.h.in	
	${CMAKE_BINARY_DIR}

	# For the globals/globals.hpp inclusion
	${CMAKE_SOURCE_DIR}

	${CMAKE_SOURCE_DIR}/libmass
	${CMAKE_SOURCE_DIR}/libmassgui
	${CMAKE_SOURCE_DIR}/minexpert/nongui
	${CMAKE_SOURCE_DIR}/minexpert/gui

	${CMAKE_BINARY_DIR}/libmass
	${CMAKE_BINARY_DIR}/libmassgui

	# For the ui_Xyyyyy.h files of both modules.
	${CMAKE_BINARY_DIR}/massxpert
	${CMAKE_BINARY_DIR}/minexpert

	${CMAKE_CURRENT_SOURCE_DIR}

	${Qt5Widgets_INCLUDE_DIRS}
	${Qt5Xml_INCLUDE_DIRS}
	${Qt5Svg_INCLUDE_DIRS}
	${Qt5Sql_INCLUDE_DIRS}
	${Qt5Script_INCLUDE_DIRS}
	${Qt5PrintSupport_INCLUDE_DIRS}
	/usr/include/proteowizard
	)

target_include_directories(${TARGET} PRIVATE
	${INCLUDE_DIRECTORIES}
	)


# Now handle the private libraries for non-gui stuff (libmass.a) and gui stuff
# (libmassgui.a)
set(MASSLIB -Wl,-whole-archive ${CMAKE_BINARY_DIR}/libmass/libmass.a -Wl,-no-whole-archive)
set(MASSGUILIB -Wl,-whole-archive ${CMAKE_BINARY_DIR}/libmassgui/libmassgui.a -Wl,-no-whole-archive)

set(required_target_link_libraries
	${MASSLIB}
	${MASSGUILIB}
	${OPENMP_LIBRARY}	
	Qt5::Widgets
	Qt5::Xml
	Qt5::Svg
	Qt5::Sql
	Qt5::Script
	Qt5::PrintSupport
	"qcustomplot"
	pwiz)

### Debugging stuff
#message(STATUS required_target_link_libraries: ${required_target_link_libraries})
#get_property(dirs DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY INCLUDE_DIRECTORIES)
#foreach(dir ${dirs})
#message(STATUS "included dir='${dir}'")
#endforeach()

target_link_libraries(${TARGET}
	${required_target_link_libraries})

# Add an explicit dependency to libmass and libmassgui so that when invoking
# make from inside the massxpert bin build dir, the dependencies get built.
add_dependencies(${TARGET} mass massgui)

message("")
message(STATUS "${BoldGreen}Finished processing ${PATHNAME} dir.${ColourReset}")
message("")

=== doc/user-manual/CMakeLists.txt ===
if(BUILD_USER_MANUAL)

  message("")
  message(STATUS "${BoldGreen}Starting configuration for the user manual for ${CMAKE_PROJECT_NAME} ${ColourReset}")
  message("")

  # The version of the program needs to be set in the user manual front
  # matter.
  CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/CMakeStuff/user-manual-version-entity.ent.in
    ${CMAKE_SOURCE_DIR}/doc/user-manual/xml/user-manual-version-entity.ent @ONLY)


  # The location of the main user manual config file (set fop.xconf file
  # location)
  set(FOP_XCONF_DIR ${CMAKE_SOURCE_DIR}/doc/user-manual)
  CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/CMakeStuff/DC-user-manual.cmake.in
    ${CMAKE_SOURCE_DIR}/doc/user-manual/DC-user-manual @ONLY)

  # Command:
  # make usermanual
  # Makes use of the local  Makefile file.
  # Will generate HTML and PDF documentation in the build directory

  message("\tConfiguring the user manual compilation")

  add_custom_target(usermanual
    COMMAND make all_f
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    COMMENT "Build of the DocBook-based user manual documentation")

  install(FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/build/user-manual/${TARGET}-doc.pdf
    DESTINATION ${DOC_DIR})

  install(DIRECTORY 
    ${CMAKE_CURRENT_SOURCE_DIR}/build/user-manual/html/user-manual/
    DESTINATION ${DOC_DIR}/html)

  message("")
  message(STATUS "${BoldGreen}Finished configuring the ${CMAKE_PROJECT_NAME} user manual.${ColourReset}")
  message("")

else()

  message(STATUS "User manual build skipped")

endif()

=== doc/user-manual/Makefile ===
project=massxpert

# This path represents the local file even if it is a symbolic link
mkfile_path := $(abspath $(lastword $(MAKEFILE_LIST)))
current_dir := $(notdir $(patsubst %/,%,$(dir $(mkfile_path))))

pwd=$(CURDIR)
topDir=${pwd}

okularPid=${topDir}/okular.pid

pdfFilePath=${topDir}/build/user-manual
pdfFilePathName=${pdfFilePath}/user-manual_color_en.pdf 
htmlDirPath=${topDir}/build/user-manual/html/${project}-user-manual

default: all

all: pdf_f html_f

all_f: pdf_f html_f

all_f_r: pdf_f_r html_f_r

.PHONY: reader
reader:
	okular --geometry 1268x1099-0-34 $(pdfFilePathName) & echo $$! > okular.pid

# Make the pdf file without forcing without reload
pdf:
	daps -d ${topDir}/DC-user-manual --verbosity=3 pdf
	cp -fv ${pdfFilePathName} ${pdfFilePath}/${project}-doc.pdf
	cp -fv ${pdfFilePathName} ${topDir}/${project}-doc.pdf

# Make the pdf file with forcing remaking all the targets and without reload
pdf_f:
	daps --force -d ${topDir}/DC-user-manual --verbosity=3 pdf
	cp -fv ${pdfFilePathName} ${pdfFilePath}/${project}-doc.pdf
	cp -fv ${pdfFilePathName} ${topDir}/${project}-doc.pdf

# Reload with okular variant
pdf_r: pdf
	(cd ${topDir} && qdbus org.kde.okular-$(shell cat ${okularPid}) /okular reload)
	cp -fv ${pdfFilePathName} ${pdfFilePath}/${project}-doc.pdf
	cp -fv ${pdfFilePathName} ${topDir}/${project}-doc.pdf

# Reload with okular variant
pdf_f_r: pdf_f
	(cd ${topDir} && qdbus org.kde.okular-$(shell cat ${okularPid}) /okular reload)
	cp -fv ${pdfFilePathName} ${pdfFilePath}/${project}-doc.pdf
	cp -fv ${pdfFilePathName} ${topDir}/${project}-doc.pdf

.PHONY: html
html:
	daps -d ${topDir}/DC-user-manual --verbosity=3 html --static

.PHONY: html_f
html_f: html
	daps --force -d ${topDir}/DC-user-manual --verbosity=3 html --static

.PHONY: html_r
html_r: html
	firefox-reload-page.sh

.PHONY: html_f_r
html_f_r: html_f
	firefox-reload-page.sh

package_html:
	daps -d ${topDir}/DC-user-manual package-html

check_dir:
	echo "mkfile_path: $(mkfile_path)"
	echo "current_dir: $(current_dir)"	

	if [ -d "xml" ];\
	 	then \
		echo "Not in a user manual top source directory.";\
		exit 1;\
		fi

=== debian/changelog ===
massxpert (7.0.0-2) unstable; urgency=low

  * d/control: update version of daps dependency package to 3.3.2;
  * d/control: remove useless build dependencies;
  * debian/source/lintian-overrides: reinstate.

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 19 Dec 2022 17:35:50 +0100

massxpert (7.0.0-1) unstable; urgency=low

  * Major release with all the code ported to Qt6. This release is a Qt6-based
    build.

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 31 Oct 2022 21:31:52 +0100

=== debian/control ===
Source: massxpert
Section: science
Priority: optional
Maintainer: The Debichem Group <debichem-devel@lists.alioth.debian.org>
Uploaders: Filippo Rusconi <lopippo@debian.org>
Build-Depends: debhelper-compat (= 12),
 dpkg-dev (>= 1.18.25),
 graphicsmagick-imagemagick-compat,
 qt6-base-dev,
 libqt6svg6-dev,
 cmake (>= 3.12),
 daps (>= 3.3.2),
 docbook-xml,
 libjs-jquery,
 libjs-highlight.js,
 texlive-fonts-extra (>= 2020.20210202),
 fonts-ebgaramond-extra,
 fonts-urw-base35,
 docbook-to-man
Standards-Version: 4.6.1
Homepage: http://www.msxpertsuite.org/
Vcs-Browser: https://salsa.debian.org/debichem-team/massxpert
Vcs-Git: https://salsa.debian.org/debichem-team/massxpert.git


Package: massxpert
Architecture: any
Depends: ${shlibs:Depends},
				 ${misc:Depends},
         massxpert-data (>= ${source:Upstream-Version})
Suggests: massxpert-doc (>= ${source:Upstream-Version})
Replaces: msxpertsuite-massxpert (<< 6.0.0)
Breaks: msxpertsuite-massxpert (<< 6.0.0)
Conflicts: msxpertsuite-massxpert
Description: polymer chemistry modelling and mass spectrometry data simulation (runtime)
 massXpert allows the user to perform the following tasks:
 .
  - Make brand new polymer chemistry definitions;
  - Use the definitions to easily perform calculations in a desktop
    calculator-like manner;
  - Perform sophisticated polymer sequence editing and simulations;
  - Perform m/z list comparisons;
 .
 Chemical simulations encompass cleavage (either chemical or
 enzymatic), gas-phase fragmentations, chemical modification of any
 monomer in the polymer sequence, cross-linking of monomers in the
 sequence, arbitrary mass searches...
 .
 This package ships the massXpert program.


Package: massxpert-data
Architecture: all
Depends: ${misc:Depends},
Suggests: massxpert-doc (>= ${source:Upstream-Version})
Replaces: msxpertsuite-massxpert-data-doc (<< 6.0.0)
Breaks: msxpertsuite-massxpert-data-doc (<< 6.0.0)
Conflicts: msxpertsuite-massxpert-data-doc
Description: polymer chemistry modelling and mass spectrometry data simulation (data)
 massXpert allows the user to perform the following tasks:
 .
  - Make brand new polymer chemistry definitions;
  - Use the definitions to easily perform calculations in a desktop
    calculator-like manner;
  - Perform sophisticated polymer sequence editing and simulations;
  - Perform m/z list comparisons;
 .
 Chemical simulations encompass cleavage (either chemical or
 enzymatic), gas-phase fragmentations, chemical modification of any
 monomer in the polymer sequence, cross-linking of monomers in the
 sequence, arbitrary mass searches...
 .
 This package ships the polymer chemistry data.


Package: massxpert-doc
Section: doc
Architecture: all
Depends: libjs-jquery,
         libjs-highlight.js,
         ${misc:Depends}
Replaces: msxpertsuite-massxpert-data-doc (<< 6.0.0)
Breaks: msxpertsuite-massxpert-data-doc (<< 6.0.0)
Conflicts: msxpertsuite-massxpert-data-doc
Description: polymer chemistry modelling and mass spectrometry data simulation (doc)
 massXpert allows the user to perform the following tasks:
 .
  - Make brand new polymer chemistry definitions;
  - Use the definitions to easily perform calculations in a desktop
    calculator-like manner;
  - Perform sophisticated polymer sequence editing and simulations;
  - Perform m/z list comparisons;
 .
 Chemical simulations encompass cleavage (either chemical or
 enzymatic), gas-phase fragmentations, chemical modification of any
 monomer in the polymer sequence, cross-linking of monomers in the
 sequence, arbitrary mass searches...
 .
 This package ships the user manual in both PDF and HTML formats.

=== debian/rules ===
#!/usr/bin/make -f
# Based on the initial work of Joey Hess and Craig Small.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# Set path to this directory so that our tweaked fop script is used.
PATH := $(CURDIR)/doc/user-manual/scripts:$(PATH)
$(info PATH: $(PATH))

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk


%:
	dh $@

# Required to stop it from calling my convenience Makefile that is only used for
# my day-to-day work.
override_dh_auto_clean:

override_dh_clean:
	dh_clean
	rm -rf debian/build
	rm -rf debian/tmp

override_dh_auto_configure:
	mkdir -p debian/build
	mkdir -p debian/tmp
	cd debian/build && cmake -DBUILD_USER_MANUAL=1 -DCMAKE_INSTALL_PREFIX=/usr ../..

	# Ensure that the fop.xconf file is found in the DC* files
	# that are located in $(CURDIR)/doc/user-manual

	cd doc/user-manual && \
		sed -i 's|/home/rusconi/devel/massxpert/development/doc/user-manual/fop.xconf|$(CURDIR)/doc/user-manual/fop.xconf|' DC-user-manual

override_dh_auto_build:
	cd debian/build && make
	cd debian/build && make usermanual

override_dh_compress:
	dh_compress -X.pdf

override_dh_auto_install:
	cd debian/build && DESTDIR=../tmp make install
	dh_install
